#include <linux/fs.h>
#include <linux/mm.h>
#include <linux/malloc.h>
#include <linux/unistd.h>

static int do_mod_firmware_load(const char *fn, char **fp)
{
	int fd;
	long l;
	char *dp;
	fd=sys_open(fn, 0, 0);
	if(fd==-1)
	{
		printk(KERN_INFO "Unable to load '%s'.\n",fn);
		return 0;
	}
	l=sys_lseek(fd, 0L,2);
	if(l<=0||l>65535)
	{
		printk(KERN_INFO "Invalid firmware '%s'\n",fn);
		sys_close(fd);
		return 0;
	}
	sys_lseek(fd,0L,0);
	dp=kmalloc(l, GFP_KERNEL);
	if(dp==NULL)
	{
		printk(KERN_INFO "Out of memory loading '%s'.\n",fn);
		sys_close(fd);
		return 0;
	}
	if(sys_read(fd,dp,l)!=l)
	{
		printk(KERN_INFO "Failed to read '%s'.\n",fn);
		kfree(dp);
		sys_close(fd);
		return 0;
	}
	sys_close(fd);
	*fp=dp;
	return (int)l;
}
	
int mod_firmware_load(const char *fn, char **fp)
{
	int r;
	int fs=get_fs();
	set_fs(get_ds());
	r=do_mod_firmware_load(fn,fp);
	set_fs(fs);
	return r;
}
